/*
 * clockspeed.c:
 *
 * Copyright (c) 2001 James McKenzie <james@fishsoup.dhs.org>,
 * All rights reserved.
 *
 */

static char rcsid[] =
  "$Id: clockspeed.c,v 1.1 2001/12/16 16:51:27 root Exp root $";

/*
 * $Log: clockspeed.c,v $
 * Revision 1.1  2001/12/16 16:51:27  root
 * Initial revision
 *
 */

#include <stdio.h>
#include <sys/types.h>
#include <sys/time.h>
#include <time.h>
#include <stdlib.h>

int
main (int argc, char *argv[])
{
  unsigned long l1, h1, l, h;
  struct timeval tv1, tv2, tv3;
  double d, de, c;

  printf("%s\n",rcsid);
  printf("(c) 2001 James McKenzie - No warranty\n");

   


  gettimeofday (&tv1, NULL);
  asm __volatile__ ("rdtsc\n":"=a" (l1), "=d" (h1):);
  gettimeofday (&tv3, NULL);
  while (tv1.tv_usec == tv3.tv_usec)
    {
      gettimeofday (&tv3, NULL);
      asm __volatile__ ("rdtsc\n":"=a" (l1), "=d" (h1):);
    }


if (argc==2) {
  sleep(atoi(argv[1]));
} else {
  sleep (1);
}

  gettimeofday (&tv2, NULL);
  asm __volatile__ ("rdtsc\n subl %%ebx,%%eax\n sbbl %%ecx,%%edx\n":"=a" (l),
                    "=d" (h):"b" (l1), "c" (h1));


  c = (double) h;
  c *= (double) 0x100000000;
  c += (double) l;

  d = (double) tv2.tv_usec;
  d -= (double) tv1.tv_usec;
  d = d / 1000000.0;
  d += (double) tv2.tv_sec;
  d -= (double) tv1.tv_sec;

  de = (double) tv3.tv_usec;
  de -= (double) tv1.tv_usec;
  de = de / 1000000.0;
  de += (double) tv3.tv_sec;
  de -= (double) tv1.tv_sec;
  de *= 2;


  c = c / 1000000.0;



  printf ("Speed is %.1f MHz [%.5f-%.5f]\n", c / d, c / (d + de),
          c / (d - de));


  return 0;
}
